function DMMainTabbar(page) {
    
    // 通过globalTabbar保持app状态，避免更新时覆盖状态
    if ("undefined" == typeof globalTabbar) {
        globalTabbar = {
            shopcartCount : 0,
            mineCount : 0,
            currentPageIndex : -1,
            presaleInfo : {
                title : null,
                normalImageSrc : null,
                activeImageSrc : null,
                pageUrl : null
            }
        };
    }
    
    
    var Nav = com.dmall.Navigator;
    
    //Nav.registRedirect("app://home","up://Dmall/Pages/DMTestPage.xml");
    
    function startWith(str,prefix) {
        return str.indexOf(prefix) == 0;
    }
    
    function urlMatch(str,strPrefix) {
        var left = str;
        var right = strPrefix;
        var index = left.indexOf('?');
        if(index > 0) {
            left = left.substring(0,index);
        }
        index = right.indexOf('?');
        if(index > 0) {
            right = right.substring(0,index);
        }
        return left == right;
    }
    
    function changeTabIfNeed(index) {
        if(globalTabbar.currentPageIndex == index) {
            return;
        }
        globalTabbar.currentPageIndex = index;
        page.changeTabState(index);
    }
    
    var mainUrls = [
                    "app://home?@animate=null&@jump=true",
                    "app://category?@animate=null&@jump=true",
                    "app://presale?@animate=null&@jump=true",
                    "app://shopcart?@animate=null&@jump=true",
                    "app://mine?@animate=null&@jump=true"
                    ]
    
    // 以下方法是暴露给app调用的，请勿删掉
    window.tabbar = {};
    window.tabbar.onPageChangeTo = function(url) {
        var durl = decodeURI(url);
        for(var index in mainUrls) {
            var u = mainUrls[index];
            if(urlMatch(durl,u)) {
                changeTabIfNeed(index);
                return;
            }
        }
    }
    window.tabbar.isMainPage = function(url) {
        var durl = decodeURI(url);
        for(var index in mainUrls) {
            var u = mainUrls[index];
            if(urlMatch(durl,u)) {
                return true;
            }
        }
        return false;
    }
    window.tabbar.setShopcartCount = function(count) {
        globalTabbar.shopcartCount = count;
        page.tabs[3].getPage().setNewCount(""+count);
    }
    
    window.tabbar.setMineCount = function(count) {
        globalTabbar.mineCount = count;
        page.tabs[4].getPage().setNewCount(""+count);
    }
    window.tabbar.setPresaleInfo = function(title,normalImageSrc,activeImageSrc,pageUrl) {
        globalTabbar.presaleInfo.title = title;
        globalTabbar.presaleInfo.normalImageSrc = normalImageSrc;
        globalTabbar.presaleInfo.activeImageSrc = activeImageSrc;
        globalTabbar.presaleInfo.pageUrl = pageUrl;
        
        
        var presaleTab = page.tabs[2];
        if(title == null) {
            presaleTab.setGone("true");
            return;
        }
        presaleTab.setGone("false");
        var data = {
            title : title,
            normalImageSrc : normalImageSrc,
            activeImageSrc : activeImageSrc
        }
        presaleTab.getPage().populate(data);
        
        if(pageUrl != null) {
            var index = pageUrl.indexOf('?');
            if(index > 0) {
                pageUrl = pageUrl + "&@animate=null&@jump=true";
            } else {
                pageUrl = pageUrl + "?@animate=null&@jump=true";
            }
        }
        
        mainUrls[2] = pageUrl;
    }
    
    
    
    // 初始化tab基本信息
    page.tabs[0].getPage().populate({
                                    title : "首页",
                                    normalImageSrc : "Images/icon_tab_home.png",
                                    activeImageSrc : "Images/icon_tab_home_active.gif"
                                    });
    page.tabs[1].getPage().populate({
                                    title : "分类",
                                    normalImageSrc : "Images/icon_tab_category.png",
                                    activeImageSrc : "Images/icon_tab_category_active.gif"
                                    });
    page.tabs[2].getPage().populate({
                                    title : "预售",
                                    normalImageSrc : "Images/icon_tab_presale.png",
                                    activeImageSrc : "Images/icon_tab_presale_active.gif"
                                    });
    page.tabs[3].getPage().populate({
                                    title : "购物车",
                                    normalImageSrc : "Images/icon_tab_shopcart.png",
                                    activeImageSrc : "Images/icon_tab_shopcart_active.gif"
                                    });
    page.tabs[4].getPage().populate({
                                    title : "我",
                                    normalImageSrc : "Images/icon_tab_mine.png",
                                    activeImageSrc : "Images/icon_tab_mine_active.gif"
                                    });
    
    page.tabs[3].getPage().upperView.setGid("shopcartIcon");
    
    
    // 设置初始显示数字
    page.tabs[3].getPage().setNewCount(""+globalTabbar.shopcartCount);
    page.tabs[4].getPage().setNewCount(""+globalTabbar.mineCount);
    
    
    // 注册tabbar点击事件处理
    for(var i in page.tabs) {
        var tab = page.tabs[i];
        tab.setOnClick("onTabClicked("+i+")");
        tab.setOnDoubleClick("onTabDoubleClicked("+i+")");
    }
    

    page.changeTabState = function(index) {
        for(var i in page.tabs) {
            var tab = page.tabs[i];
            var p = tab.getPage();
            if(i == index) {
                p.setSelected(true);
            } else {
                p.setSelected(false)
            }
        }
    }
    
    // tabbar点击处理
    page.onTabClicked = function(index) {
        page.changeTabState(index);
        
        // 如果当前已经是该页面,则无需再次跳转
        if(globalTabbar.currentPageIndex == index) {
            return;
        }
        globalTabbar.currentPageIndex = index;
        
        
        Nav.forward(mainUrls[index]);
    }


    
    page.onTabDoubleClicked = function(index) {
        Nav.rollup();
    }
    
    
    // 默认选中主页Tabbar
    if(globalTabbar.currentPageIndex >= 0) {
        page.onTabClicked(globalTabbar.currentPageIndex);
    } else {
        page.onTabClicked(0);
    }
    
    window.tabbar.setPresaleInfo(globalTabbar.presaleInfo.title,globalTabbar.presaleInfo.normalImageSrc,globalTabbar.presaleInfo.activeImageSrc,globalTabbar.presaleInfo.pageUrl);
}

